#include <unistd.h>
#include "display.h"

const char *no_code_str = "";
const char *set_fg_str = "[3%im";
const char *set_bg_str = "[4%im";
const char *goto_xy_str = "[%i;%iH";
const char *clear_str = "[H[J";

const char *normal_str = "[0m";
const char *onboldfg_str = "[1m";
const char *offboldfg_str = "[21m";
const char *onboldbg_str = "[5m";
const char *offboldbg_str = "[25m";
const char *onunder_str = "[2m";
const char *offunder_str = "[22m";
const char *onrev_str = "[3m";
const char *offrev_str = "[23m";

void init_c0des() {
	if (! isatty(1)) {
		// no formatting when we aren't a tty
		set_fg_str = no_code_str;
		set_bg_str = no_code_str;
		goto_xy_str = no_code_str;
		clear_str = no_code_str;
		normal_str = no_code_str;
		onboldfg_str = no_code_str;
		offboldfg_str = no_code_str;
		onboldbg_str = no_code_str;
		offboldbg_str = no_code_str;
		onunder_str = no_code_str;
		offunder_str = no_code_str;
		onrev_str = no_code_str;
		offrev_str = no_code_str;
	}
}

#if 0
int main() {
	init_c0des();

	clear_scr();

	for (int i = 0; i < 8; i++) {
			normal_scr();
			goto_xy(0,i*3);
			set_fg(i);
			printf("%x", i);
			set_bold_fg();
			printf("%x", i);
	}
	printf("\n");

	for (int i = 0; i < 8; i++) {
			normal_scr();
			goto_xy(i*2,0);
			set_bg(i);
			printf("%x", i);
			set_bold_bg();
			printf("%x", i);
	}
	printf("\n");

	normal_scr();

	return 0;
}
#endif
