#include "deep_zoom.h"

// saves the image of the fractal to a png file with the name given in fname

void write_image_to_file(FRACTAL *f, const char *fname)
{
  Imlib_Image image;
  Colormap cm;

  image=imlib_create_image_using_data(f->width, f->height, f->image_data);
  imlib_context_set_image(image);
  cm=imlib_context_get_colormap();
  imlib_image_set_format("png");

  imlib_save_image(fname);
  imlib_free_image();
}
