class trieNode {
   public:
	int code;
	char depth;

	trieNode(char d) : code(0), depth(d) {}

	virtual trieNode *lookup(char *str, int len) = 0;
	virtual trieNode *add(char *str, int len, int val) = 0;
};

class loSatTN : public trieNode {
   public:
   	trieNode **ptr;
	trieNode *c[3];
	short v[3];

	loSatTN(char d, trieNode **p);
	virtual ~loSatTN();
	trieNode *add(char *str, int len, int val);
	trieNode *lookup(char *str, int len);
};

class hiSatTN : public trieNode {
   public:
	trieNode *c[256];

	hiSatTN(char d);
	hiSatTN(loSatTN &tn);
	trieNode *add(char *str, int len, int val);
	trieNode *lookup(char *str, int len);
};

